// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit mycollisiontrick;

interface

procedure FixPosition(var px,py,pz:single; sx,sy,sz:single; radius:single; elapsed:single);

implementation

procedure FixPosition(var px,py,pz:single; sx,sy,sz:single; radius:single; elapsed:single);
var vx,vy,vz:single;
    vlen:single;
begin
 vx:=px-sx;
 vy:=py-sy;
 vz:=pz-sz;

 vlen:=sqrt(vx*vx+vy*vy+vz*vz);

 if vlen>radius then
  begin
   vx:=vx/vlen;
   vy:=vy/vlen;
   vz:=vz/vlen;

   px:=sx+vx*radius;
   py:=sy+vy*radius;
   pz:=sz+vz*radius;
  end;

py:=py+(sy-py)*elapsed;

end;

end.
