// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit mytextures;

interface

uses OpenGL,exgine;

type TTexture = record
                 openglID : GLUint;
                 filename : string;
                end;

type TTextures = array of TTexture;                  

function LoadMyTexture(var mytextures:TTextures;filename:string):integer;

implementation

function LoadMyTexture(var mytextures:TTextures;filename:string):integer;
var k:integer;
    alreadyLoaded:boolean;
begin
alreadyLoaded:=false;
result:=-1;

for k:=0 to length(mytextures)-1 do
  if mytextures[k].filename=filename then
   begin
    alreadyLoaded:=true;
    result:=mytextures[k].openglID;
   end;

  if not alreadyLoaded then
   begin
    k:=length(mytextures);
    setlength(mytextures,k+1);
    mytextures[k].filename:=filename;
    mytextures[k].openglID:=tex.Load(PChar(filename));
    result:=mytextures[k].openglID;
   end;

end;

end.

