// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit myvectors;

interface

uses math,sysutils;

type TVector=record
                x,y,z:single;
               end;

type TVectors=array of TVector;


function vectorLerp(v1,v2:TVector;factor:single):TVector;


implementation

function vectorLerp(v1,v2:TVector;factor:single):TVector;
begin
result.x:=v1.x + (v2.x - v1.x) * factor;
result.y:=v1.y + (v2.y - v1.y) * factor;
result.z:=v1.z + (v2.z - v1.z) * factor;
end;

end.
